<template>
  <div class="prk-order__container prk-order--step-finish prk-order__container--shadow">
      <popupEror 
           v-if="responsEror && clousPopup" 
           :eror="responsEror"
           v-on:clous-popup="clousPopup = false;noScroll();"
      />
      <h2 class="prk-order__title">PAIEMENT</h2>
      <ProgressForm
        :currentItem="4"
      />
      <div class="prk-order__note">
        Livraison d’une citadine assurée jusqu’à 80 000 €, par un driver professionnel le <span class="prk-order__note-date">{{dataStepTwo.date.dataStr}}</span>
      </div>
      <div class="prk-order__form-four">
      <form @submit.stop.prevent>
        <div class="row">
          <!--Name Paymetnt-->
          <div class="prk-order__form-item col-md-6">
            <label v-if="stripePayment" class="prk-order__label">Nom du bénéficiaire de la carte</label>
            <label else="stripePayment" class="prk-order__label">Name</label>
            <input 
              type="text" 
              name="nameUser" 
              v-model.trim="nameUser"
              class="prk-order__input"
              :class="{'prk-order__is-invalid': reqNameUser && attemptSubmit}"
              >
            <div class="prk-order__invalid" v-if="stripePayment && reqNameUser && attemptSubmit">
                Le nom du destinataire de la carte est un champ obligatoire.
            </div>
            <div class="prk-order__invalid" v-if="sepaPayment && reqNameUser && attemptSubmit">
                Le nom est un champ obligatoire.
            </div>
          </div>
          <!--checkbox Paymetnt-->
          <div class="prk-order__form-item col-md-6">
            <label class="prk-order__label">Comment souhaitez-vous payer?</label>
            <div class="row">
              <div class="col-6">                
                <label class="prk-order__container-checkbox">Prélèvement bancaire
                  <input 
                    type="checkbox" 
                    name="stripePayment" 
                    v-model="stripePayment"
                    @click="paymentMethod($event);">
                  <span class="prk-order__radio"></span>
                </label>
              </div>
              <div class="col-6">
                <label class="prk-order__container-checkbox">Paiement en ligne
                  <input 
                    type="checkbox" 
                    name="sepaPayment" 
                    v-model="sepaPayment"
                    @click="paymentMethod($event);">
                  <span class="prk-order__radio"></span>
                </label>
              </div>    
            </div> 
          </div>
          <!--Stripe Paymetnt-->
          <div class="prk-order__form-item col-md-6" v-show="stripePayment">
            <label class="prk-order__label">Card</label>
              <div id="containerCard" ref="card"></div>
              <div class="prk-order__invalid" v-if="invalidCard.bool">
                     {{invalidCard.message}}
              </div>
          </div>
          <!--Sepa Payment-->
          <div class="prk-order__form-item col-md-6" v-if="sepaPayment">
                <label class="prk-order__label">E-mail</label>
                <input 
                  type="email"  
                  name="Mail" 
                  v-model.trim="formDataObjSepa.emailUser" 
                  class="prk-order__input"
                  :class="{'prk-order__is-invalid': (reqMail || validMail) && attemptSubmit}">
                <div class="prk-order__invalid" v-if="reqMail && attemptSubmit">
                     S'il vous plaît entrer votre email
                </div>
                <div class="prk-order__invalid" v-if="!reqMail && attemptSubmit && validMail">
                     S'il vous plaît entrer une adresse email valide
                </div>
          </div>
          <div class="prk-order__form-item col-md-6" v-show="sepaPayment">
            <label class="prk-order__label">Iban</label>
              <div id="containerIban" ref="iban"></div>
              <div class="prk-order__invalid" v-if="invalidSepa.bool">
                     {{invalidSepa.message}}
                </div>
          </div>
        </div>
        <div class="prk-order__action">
          <button 
            type="submit"
            :class="{'prk-order__loader':loadRespons}"
            :disabled="loadRespons"
            class="prk-order__button prk-order__button--next" 
            @click="validateForm()?purchase():null;">
              TERMINER
          </button>
        </div>
      </form>
      <div class="flex justify-content-center">
        <button  class="prk-order__button prk-order__button--no-bg prk-order__button--prev" @click="$emit('prev-step')">REVENIR</button>
      </div>
    </div>  
  </div>  
</template>

<script>
import ProgressForm from './ProgressForm.vue'
import popupEror from './popupEror.vue'
import axios from 'axios'

let stripeCard = Stripe(/*stripeKey*/),
    stripeSepa = Stripe(/*sepaKey*/),
    elementsCard = stripeCard.elements(),
    elementsSepa = stripeSepa.elements(), 
    iban = undefined,
    card = undefined, 
    style = {
  base: {
    color: '#a8a8a8',
    fontFamily: '-apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Helvetica, Arial, sans-serif',
    fontSmoothing: 'antialiased',
    fontSize: '16px',
    '::placeholder': {
      color: '#aab7c4'
    },
    ':-webkit-autofill': {
      color: '#a8a8a8',
    },
  },
  invalid: {
    color: '#c30404',
    iconColor: '#c30404',
    ':-webkit-autofill': {
      color: '#c30404',
    },
  }

};

export default {
  name: 'FromStepFinish',
  props: {
    dataStepTwo: Object
  },
  components: {
    ProgressForm,
    popupEror
  },
  data() {
    return {
      loadRespons: null,
      responsEror: false,
      clousPopup: false,
      attemptSubmit: false,
      stripePayment: true,
      sepaPayment: false,
      hasCardErrors: false,
      nameUser: '',
      invalidSepa:{
        bool: false,
        message: '',
      },
       invalidCard:{
        bool: false,
        message: '',
      },
      formDataObjStripe:{
        name: 'card',
        response: null,
      },
      formDataObjSepa:{
        name: 'sepa',
        response: null,
        emailUser: '',
      },
      regMail: /^(([^<>()\\.,;:\s@"]+(\.[^<>()\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
    }
  },
  methods: {
    validateForm() {
      this.attemptSubmit = true;
      if(this.stripePayment && this.reqNameUser){
          return false;
      }else if(this.sepaPayment && (this.reqMail || this.validMail || this.reqNameUser)){
          return false;
      }else{
        this.loadRespons = true; 
        return true;
      }
    },
    paymentMethod(e){
      if(e.target.name == 'stripePayment'){
        this.sepaPayment = false;
      }else{
        this.stripePayment = false;
      }
    },
    purchase() {
      let self = this;
      if(this.stripePayment){
        stripeCard.createToken(card).then(function(result) {
            self.formDataObjStripe.response = result;
          if (result.error) {
              self.invalidCard.message = result.error.message;
              self.invalidCard.bool = true;
              self.loadRespons = false; 
            return;
          }else{
            self.invalidCard.bool = false;
            self.backRequest();
          }
        });
      }else{
        let sourceData = {
          type: 'sepa_debit',
          currency: 'eur',
          owner: {
            name: this.nameUser,
            email: this.formDataObjSepa.emailUser,
          },
          mandate: {
            notification_method: 'email',
          },
        };
        stripeSepa.createSource(iban, sourceData).then(function(result) {
            self.formDataObjSepa.response = result;
            if (result.error) {
              self.invalidSepa.message = result.error.message;
              self.invalidSepa.bool = true; 
              self.loadRespons = false;  
            return;
          }else{
            self.invalidSepa.bool = false;
            self.backRequest();
          }
        });
      }
    },
    backRequest(){
      let sendStrip;
      if(this.stripePayment){
        sendStrip = JSON.stringify(this.formDataObjStripe);
      }else{
        sendStrip = JSON.stringify(this.formDataObjSepa);
      }
      axios({
        method: 'post',
        url: '/wp-admin/admin-ajax.php',
        timeout: 60000, 
        params: {
           action: 'step_6',
        },
        data: {
          body: sendStrip,
        }
        })
       .then(response=>{
            if(response.data.error){
               this.responsEror = response.data.error.message;
               this.clousPopup = true;
            }else{
               this.responsEror = false;
               this.$emit('next-step', 'Hello');
            } 
        })
        .catch(()=>{
              this.responsEror = "Une erreur s'est produite, n'hésitez pas à contacter l'équipe Sales à contact@parkopoly.fr";
              this.clousPopup = true;
        })
        .finally(()=>{
           this.loadRespons = false;
        }); 
    },
    noScroll(){
       document.body.classList.remove('scroll-none');
    },
  },
  mounted: function(){ 
      iban = elementsSepa.create('iban', {
      style: style,
      supportedCountries: ['SEPA'],
    });
    iban.mount(this.$refs.iban);
    card = elementsCard.create('card', style);
    card.mount(this.$refs.card);
  },
  computed: {
    reqNameUser(){
        return(this.nameUser === ''? true : false);
    },
    reqMail(){
       return this.formDataObjSepa.emailUser === ''; 
    },
    validMail(){
      return  !this.regMail.test(this.formDataObjSepa.emailUser);
    }
  },
  watch: {
     loadRespons(){
        return(!this.loadRespons &&  !this.responsEror? true :null);
     }
  },
}
</script>

<style lang="stylus">
.prk-order
  &__note
    padding 18px 0 22px
    background #E9E9E9
    text-align center
    font-weight 700
    margin-bottom 35px
#containerIban,
#containerCard 
    padding 12px 20px
    width 100%
    border-radius 2px
    height 43px
    margin-bottom 20px
    border 1px solid #707070

</style>